package org.bidib.wizard.mvc.main.view.panel.listener;

import org.bidib.wizard.mvc.main.model.Node;

public interface NodeListListener extends LabelChangedListener {
    /**
     * Show the CV programmer dialog.
     * @param node the node
     * @param x the X position of the label component that displays the node
     * @param y the Y position of the label component that displays the node
     */
    void cvProgrammer(Node node, int x, int y);

    void enableAddressMessages(Node node);

    void enableDccStart(Node node);

    void enableExternalStart(Node node);

    void enableFeedbackMessages(Node node);

    void enableKeyMessages(Node node);

    /**
     * Show the node features dialog.
     * @param node the node
     * @param x the X position of the label component that displays the node
     * @param y the Y position of the label component that displays the node
     */
    void features(Node node, int x, int y);

    void exportNode(Node node);

    void firmwareUpdate(Node node, int x, int y);

    void identify(Node node);

    void importNode(Node node);

    void loco(Node node, int x, int y);

    /**
     * Show the node details.
     * @param node the node
     * @param posX the X position of the label component that displays the node
     * @param posY the Y position of the label component that displays the node
     */
    void nodeDetails(Node node, int posX, int posY);

    void saveNode(Node node);
}
